<h1><%= @title = @change_info.title %></h1>
<%= render_errors_for "bug" %>
<div class="frm">
<%= start_form_tag({:action => "update"}, "name" => "frm", :multipart => true) %>
  <input type="hidden" name="change_type" value="<%= @change_info.type %>" />
  <%= hidden_field("bug", "id") %>
  <table cellspacing="3" cellpadding="5" border="0">
    <tr>
      <td><label for="project">Project</label></td>
	<td><select name="bug[project_id]" id="project" onchange="javascript:projectChanged(this.options.selectedIndex);" style="width: 200px;">
	  <% for project in @projects -%>
	  <option value="<%= project.id %>"<%= ' selected' if project.id == @bug.project_id %>><%= project.name %></option>
	  <% end -%>
        </select>
	<script language="javascript" type="text/javascript">
	  <!--
	      var prj_ids = new Array();
	      var prj_mans = new Array();
	      <% @projects.each_with_index do |project, idx| -%>
	      prj_ids[<%= idx %>] = <%= project.id %>;
	      prj_mans[<%= idx %>] = <%= project.manager_id %>;
              <% end -%>
            //-->
	</script>
      </td>
      <td><label for="area">Area</label></td>
	<td><select name="bug[area_id]" id="area" style="width: 200px;"></select>
	<script language="javascript" type="text/javascript">
	  <!--
	      var ars = new Array();
	      var ars_ids = new Array();
	      var ars_prj_ids = new Array();
	      <% i = 0 -%>
	      <% for project in @projects -%>
	      <% for area in project.areas -%>
	      ars[<%= i %>] = '<%=jsh area.name %>';
	      ars_ids[<%= i %>] = <%= area.id %>;
	      ars_prj_ids[<%= i %>] = <%= project.id %>;
	      <% i += 1 -%>
	      <% end -%>
              <% end -%>
            //-->
	</script>
      </td>
    </tr>
    <tr>
      <td>
	<label id="title" for="title">Title</label>
      </td>
      <td colspan="3">
        <%= text_field("bug", "title", "id" => "title", "size" => 60, "maxlength" => 255) %>
      </td>
    </tr>
  </table>
  <fieldset>
    <legend>Info</legend>
    <table width="100%" cellspacing="4">
      <tr>
	<td width="40%"><label for="status">Status</label></td>
	<% if @change_info.status_map.size > 1 -%>
	<td><select name="bug[status]" id="status" style="width: 250px;">
	    <% @change_info.status_map.each do |idx, status| -%>
	    <option value="<%= idx %>"<%= ' selected' if @bug.status == idx %>><%= status %></option>
	    <% end -%>
	  </select>
	<% else -%>
	<td><span style="font-weight: bold;"><%= @change_info.status_map[0][1] %></span>
	  <input type="hidden" name="bug[status]" value="<%= @change_info.status_map[0][0] %>" />
	<% end -%>
	</td>
      </tr>
      <tr>
	<td><label for="assigned_to">Assigned To</label></td>
	<td>
	  <select name="bug[user_id]" id="assigned_to" style="width: 250px;"></select>
	  <script language="javascript" type="text/javascript">
	    <!--
		var usr_ids = new Array();
		var usr_names = new Array();
		<% @users.each_with_index do |user, idx| -%>
		usr_ids[<%= idx %>] = <%= user.id %>;
		usr_names[<%= idx %>] = '<%=jsh user.full_name %>';
		<% end -%>
	    //-->
	  </script>
	</td>
      </tr>
      <tr>
	<td><label for="category">Category</label></td>
	<td><%= select("bug", "category", Bug::CATEGORY, {}, "style" => "width: 250px;") %></td>
      </tr>
      <tr>
	<td><label for="fix_for">Fix For</label></td>
	<td>
	  <select name="bug[release_id]" style="width: 250px;"><option value="-1">Unspecified</option></select>
	  <script language="javascript" type="text/javascript">
	    <!--
	    var rels = new Array();
	    var rels_ids = new Array();
	    var rels_prj_ids = new Array();
	    <% i = 0 -%>
	    <% for project in @projects -%>
	    <% for release in project.find_all_in_releases('assignable = 1') -%>
	    rels[<%= i %>] = '<%=jsh release.name %>';
	    rels_ids[<%= i %>] = <%= release.id %>;
	    rels_prj_ids[<%= i %>] = <%= project.id %>;
	    <% i += 1 -%>
	    <% end -%>
            <% end -%>
            -->
	  </script>
	</td>
      </tr>
      <tr>
	<td><label for="priority">Priority</label></td>
	<td><select name="bug[priority_id]" style="width: 250px;">
	    <% for priority in @priorities -%>
	    <option value="<%= priority.id %>"<%= ' selected' if priority.id == @bug.priority_id %>><%= priority.full_title %></option>
	    <% end -%>
	</select></td>
      </tr>
      <tr>
	<td valign="top"><label for="estimate">Estimate</label></td>
	<td>
	  <%= text_field("bug", "estimate", "size" => 30, "id" => "estimate") %>
          <div class="small_note">Use d for days, h for hours, and m for minutes,<br />for example <strong>1d4h</strong></div>
        </td>
      </tr>
      <tr>
	<td><label for="version">Version</label></td>
	<td><%= text_field("bug", "version", "size" => 30, "id" => "version") %></td>
      </tr>
    </table>
  </fieldset>
  <div class="btn"><input type="submit" value="Save Task"/>&nbsp;<input type="button" value="Cancel" onclick="javascript:window.location = '<%= url_for :action => "show", :id => @bug.id %>'" /></div>

  <p>
    <div class="change_header"><span class="change_type"><%= @change_info.type_name %> by</span>&nbsp;
      <%= link_to logged_user.user_name, :controller => 'user', :action => 'show', :id => logged_user.id %>&nbsp;
      <span class="change_date"><%= Time.now.strftime('%m/%d/%Y %I:%M %p') %></span>
    </div>
    <textarea name="msg" cols="75" rows="15"><%= @msg %></textarea>
    <div id="formatips">Textile formatting tips (<a href="#" onClick="quickRedReference(); return false;">show</a>)</div>
    <div id="attachment"><label for="attach_file">Attach file:</label><input id="attach_file" type="file" name="attachment" size="40" /></div>
  </p>
<%= end_form_tag %>
<div id="history">  
  <h3>Change History</h3>
  <%= render_collection_of_partials "change", @bug.full_changes %>
  <div id="backtop"><a href="#topmost" title="Jump to the top">Back to Top</a> ^</div>
</div>
</div>
<script language="javascript" type="text/javascript">
<!--
    function quickRedReference() {
      window.open( 
        "http://hobix.com/textile/quick.html",
        "redRef",
        "height=600,width=550,channelmode=0,dependent=0," +
        "directories=0,fullscreen=0,location=0,menubar=0," +
        "resizable=0,scrollbars=1,status=1,toolbar=0" 
      );
    }
    function projectChanged(x) {
      var project = document.frm['bug[project_id]'];
      // RELEASES
      var opts = document.frm['bug[release_id]'];
      for(i = opts.length - 1; i > 0; i--)
        opts[i] = null;
      var id = 1;
      for(i = 0; i < rels.length; i++) {
        if(project.options[x].value == rels_prj_ids[i]) {
          opts[id] = new Option(rels[i], rels_ids[i]);
          <% if @bug.release_id -%>
          if(rels_ids[i] == <%= @bug.release_id %>)
            opts[id].selected = true;
          <% end -%>
          id++;
        }
      }
      // AREAS
      var opts = document.frm['bug[area_id]'];
      for(i = opts.length - 1; i >= 0; i--)
        opts[i] = null;
      var id = 0;
      for(i = 0; i < ars.length; i++) {
        if(project.options[x].value == ars_prj_ids[i]) {
          opts[id] = new Option(ars[i], ars_ids[i]);
          <% if @bug.area_id -%>
          if(ars_ids[i] == <%= @bug.area_id %>)
            opts[id].selected = true;
          <% end -%>
          id++;
        }
      }
      // USERS
      var opts = document.frm['bug[user_id]'];
      for(i = opts.length - 1; i >= 0; i--)
        opts[i] = null;
      //find the current project manager id
      var prj_manager = -1;
      for(i = 0; i < prj_ids.length; i++) {
        if(prj_ids[i] == project.options[x].value)
          prj_manager = prj_mans[i];
      }
      for(i = 0; i < usr_ids.length; i ++) {
        if(usr_ids[i] == prj_manager)
          opts[i] = new Option(usr_names[i] + ' (Project Manager)', usr_ids[i]);
        else
          opts[i] = new Option(usr_names[i], usr_ids[i]);
        <% if @bug && @bug.user_id -%>
        var bug_project = <%= @bug.project_id %>;
        if(bug_project == project.options[x].value) {
  	  if(usr_ids[i] == <%= @bug.user_id %>)
            opts[i].selected = true;
        } else {
          if(usr_ids[i] == prj_manager)
            opts[i].selected = true;
        }
        <% else -%>
	if(usr_ids[i] == prj_manager)
          opts[i].selected = true;
        <% end -%>
      }      
    }
    projectChanged(document.frm['bug[project_id]'].options.selectedIndex);
-->
</script>
